%----------------------------------------------------------------------------------------
%	PACKAGES EN DOCUMENT CONFIGURATIE
%----------------------------------------------------------------------------------------

\documentclass[a4paper,12pt]{article}
\usepackage{graphicx}
\usepackage[english]{babel}
\usepackage{fancyhdr}
\usepackage{lastpage}
\usepackage{xifthen}
\usepackage{algorithm2e}
\usepackage{lipsum}
\usepackage{hyperref}
\usepackage[utf8]{inputenc}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{float}
\usepackage{subcaption}
%----------------------------------------------------------------------------------------
%	HEADER & FOOTER
%----------------------------------------------------------------------------------------
\pagestyle{fancy}
  \lhead{\includegraphics[width=4.5cm]{logoUU}}		%Zorg dat het logo in dezelfde map staat
  \rhead{\footnotesize \textsc {Lab report\\ \opdracht}}
  \lfoot
    {
	\footnotesize \studentA
	\ifthenelse{\isundefined{\studentB}}{}{\\ \studentB}
	\ifthenelse{\isundefined{\studentC}}{}{\\ \studentC}
	\ifthenelse{\isundefined{\studentD}}{}{\\ \studentD}
	\ifthenelse{\isundefined{\studentE}}{}{\\ \studentE}
    }
  \cfoot{}
  \rfoot{\small \textsc {Page \thepage\ of \pageref{LastPage}}}
  \renewcommand{\footrulewidth}{0.5pt}

\fancypagestyle{firststyle}
 {
  \fancyhf{}
   \renewcommand{\headrulewidth}{0pt}
   \chead{\includegraphics[width=5.5cm]{logoUU}}
   \rfoot{\small \textsc {Page \thepage\ van \pageref{LastPage}}}
 }

\setlength{\topmargin}{-0.3in}
\setlength{\textheight}{630pt}
\setlength{\headsep}{40pt}

%----------------------------------------------------------------------------------------
%	DOCUMENT INFORMATIE
%----------------------------------------------------------------------------------------
%Geef bij ieder command het juiste argument voor deze opdracht. Vul het hier in en het komt op meerdere plekken in het document correct te staan.

\newcommand{\titel}{Implementation}			%Zelfbedachte titel
\newcommand{\opdracht}{Computer Vision Assignment 3}		%Naam van opdracht die je van docent gehad hebt
\newcommand{\docent}{Ronald Poppe}
\newcommand{\cursus}{Computer Vision}
\newcommand{\vakcode}{INFOMCV}		%Te vinden op oa Datanose
\newcommand{\datum}{\today}					%Pas aan als je niet de datum van vanaag wilt hebben
\newcommand{\studentA}{Jack van der Drift}
\newcommand{\uunetidA}{4098978}
\newcommand{\studentB}{Marjolein Zwerver}			%Uncomment de regel als je met vijf studenten werkt
\newcommand{\uunetidB}{5595363}
%\newcommand{\studentC}{Naam student 3}		%Uncomment de regel als je met drie studenten werkt
\newcommand{\uunetidC}{UUnetID student 3}
%\newcommand{\studentD}{Naam student 4}		%Uncomment de regel als je met vier studenten werkt
\newcommand{\uunetidD}{UUnetID student 4}
%\newcommand{\studentE}{Naam student 5}			%Uncomment de regel als je met vijf studenten werkt
\newcommand{\uunetidE}{UUnetID student 5}

%----------------------------------------------------------------------------------------
%	AUTOMATISCHE TITEL
%----------------------------------------------------------------------------------------
\begin{document}
\thispagestyle{firststyle}
\begin{center}
	\textsc{\Large \opdracht}\\[0.2cm]
		\rule{\linewidth}{0.5pt} \\[0.4cm]
			{ \huge \bfseries \titel}
		\rule{\linewidth}{0.5pt} \\[0.2cm]
	{\large \datum  \\[0.4cm]}
	
	\begin{minipage}{0.4\textwidth}
		\begin{flushleft} 
			\emph{Students:}\\
			{\studentA \\ {\small \uunetidA \\[0.2cm]}}
				\ifthenelse{\isundefined{\studentB}}{}{\studentB \\ {\small \uunetidB \\[0.2cm]}}
				\ifthenelse{\isundefined{\studentC}}{}{\studentC \\ {\small \uunetidC \\[0.2cm]}}
				\ifthenelse{\isundefined{\studentD}}{}{\studentD \\ {\small \uunetidD \\[0.2cm]}}
				\ifthenelse{\isundefined{\studentE}}{}{\studentE \\ {\small \uunetidE \\[0.2cm]}}
		\end{flushleft}
	\end{minipage}
~
	\begin{minipage}{0.4\textwidth}
		\begin{flushright} 
			\emph{Professor:} \\
			\docent \\[0.2cm]
			\emph{Course:} \\
			\cursus \\[0.2cm]
			\emph{Course code:} \\
			\vakcode \\[0.2cm]
		\end{flushright}
	\end{minipage}\\[1 cm]
\end{center}

%----------------------------------------------------------------------------------------
%	INHOUDSOPGAVE EN ABSTRACT 
%----------------------------------------------------------------------------------------

%\tableofcontents
%\begin{abstract}
%\lorem[13]
%\end{abstract}

%----------------------------------------------------------------------------------------
%	INTRODUCTIE
%----------------------------------------------------------------------------------------
\section{Video}
This is the private link to our video of the Voxel-based Tracking:  

\url{https://youtu.be/PByE8ar_CbM}

\url{https://youtu.be/LTXcjeokPbQ}


\section{Readme}
In order to make the program work the videos need to be renamed. In order to do this please place the unzipped 4perons map in the data map and run Rename.bat. If everything went okay there should now be three .avi videos in each of the cam maps.

\section{Description}
In this assignment we try and track 4 persons through a 3D scene. We reuse the code from the first and second assignment and expand it with functions to track objects in a 3D scene. We started off by renaming the videos and moving them to different folders, so they could be used with our old code. We also redid the true foreground for a frame from camera 1 to use to obtain the optimal hsv and erode/dilate values like in the previous assignment.

In the initial code, some voxels were not being drawn when a person was walking along the edges of the space. To correct this, we extended the height parameter from 2048 to 3072. After this we started working on the clustering of the voxels. For this we use the k-means function from opencv. Together with the cluster centers and labels we get from the k-means algorithm we create a color model for the current frame of the video. We check this model against our initial color model which we obtain from frame number 1183. We have chosen this frame because it has the least amount of occlusion for all of the cameras. When we compare the color models we look at the mean squared error for all persons in all views. In order to find the correct label for each cluster we try and minimize this mean squared error by looping over every possible order of clusters and comparing the reordered color model to the initial color model. When we find the ordering that varies the least from the initial model, we reorder the labels and color the voxels accordingly.


\section{Color models}
In our color models we used the values of each voxel projection for each camera. The values we use are in the HSV representation, specifically the H values. This way, lighter and darker areas have little effect. We compute the values separately for each camera. This gives us a total of 16 values, one for every cluster in each camera view.

\subsection{Mean}
For each cluster in each of the camera’s views, the color model is the mean value of all the voxels corresponding to that cluster. When matching a frame’s color model to the initial color model, we take the squared sum of the absolute difference between the frame’s model and the initial model. In order to find the optimal combination we look for the lowest squared sum over all combinations of color models corresponding to the clusters from the initial model and color models corresponding to the clusters from the frame’s model.

\subsection{Histogram}
In the histogram model we have opencv create a histogram for us using the function calcHist. For each cluster in each camera’s view this gives us a 1 by 256 matrix. We compare the histograms of the initial model with the current model using the function compareHist, which gives us a value between 0 and 1. 1 meaning it is the exact same. We calculate the error by summing 1 - e, where e is the error rate found. We again try to find the ordering of clusters for which this error is minimized.

\subsection{Comparing color models}
When we compare the mean model with the histogram model, we can clearly see that the histogram model (Figure \ref{fig:PathsH}) is more accurate since there is less variation of color in the same path. This means that the histogram model is more consistent with the model it finds.

\begin{figure}[h]
\centering
\begin{minipage}{.5\textwidth}
  \centering
  \includegraphics[width=1\linewidth]{PathsM}
  \caption{Path of mean model}
  \label{fig:PathsM}
\end{minipage}%
\begin{minipage}{.5\textwidth}
  \centering
  \includegraphics[width=1\linewidth]{PathsH}
  \caption{Path of histogram model}
  \label{fig:PathsH}
\end{minipage}
\end{figure}

\section{Cluster improvements}

\subsection{Ghost voxels}
After implementing the k-means algorithm to cluster the voxels, we noticed that some of these clusterings were wrong (Figure \ref{fig:InitK}). In our first attempt to correct these clusters, we tried different parameters for the k-means algorithm, but unfortunately we could not resolve the error in this particular frame.

\begin{figure}[h]
	\centering
	\includegraphics[width=1\linewidth]{InitialK}
	\caption{Clusters for initial k-means algorithm}
	\label{fig:InitK}
\end{figure}

\subsection{Removing ghost voxels}
To get the k-means algorithm to converge to the correct clusters, we decided to try to remove some of these small clusters. To achieve this, we run the cluster algorithm for a larger k and find the smallest cluster. We then determine the relative size of this cluster to be the number of voxels in this cluster divided by the total number of voxels. If this relative size if below a certain percentage, we remove the voxels that belong to that cluster. We started with an algorithm that found 5 clusters and by looking at the output, determined that the optimal threshold to remove clusters was around 0.1.
From there we extended to algorithm to remove more clusters, where the threshold is lower for a higher number of clusters. An example can be found in Figure \ref{fig:clusters}, where the image number is the number of clusters that were removed.


\begin{figure}[h]
\centering
\begin{minipage}{.5\textwidth}
  \centering
  \caption*{original}
  \includegraphics[ width=0.8\linewidth]{original}
  \label{fig:original}
\end{minipage}%
\begin{minipage}{.5\textwidth}
  \centering
  \caption*{1}
  \includegraphics[, width=0.8\linewidth]{1}
  \label{fig:1}
\end{minipage}

\vspace{0.5cm}

\begin{minipage}{.5\textwidth}
  \centering
  \caption*{2}
  \includegraphics[width=0.8\linewidth]{2}
  \label{fig:2}
\end{minipage}%
\begin{minipage}{.5\textwidth}
  \centering
  \caption*{3}
  \includegraphics[width=0.8\linewidth]{3}
  \label{fig:3}
\end{minipage}

\vspace{0.5cm}

\begin{minipage}{.5\textwidth}
  \centering
  \caption*{4}
  \includegraphics[width=0.8\linewidth]{4}
  \label{fig:4}
\end{minipage}%
\begin{minipage}{.5\textwidth}
  \centering
  \caption*{5}
  \includegraphics[width=0.8\linewidth]{5}
  \label{fig:5}
\end{minipage}
\caption{Frame 1051 with different number of clusters removed}
\label{fig:clusters}
\end{figure}

Unfortunately, using the original threshold and removing 5 clusters for each frame resulted in the removal of some voxels that actually belonged to people. To find the optimal parameters we tested two different thresholds and changed the number of clusters to be removed between 1 and 5. We made our thresholds using the fact that for 5 clusters we needed a threshold of $0.1$, so the first option was t1\_size\_threshold = $0.1 / (\#clusters*2)$. We also wanted a threshold that was less likely to remove clusters for a higher cluster number so we added a threshold of t2\_size\_threshold$ = 2.5 / (\#clusters^2)$.

We then tested the different parameters for different problematic frames where people were close to each other, or more likely to disappear and found that the best results were achieved when removing 3 clusters with the t2 threshold.

\subsection{Part of pixels used for color models}
To further improve the matching of the color models we decided to remove the voxels which are very similar for each person, which would be the ones for the legs and head. From the images we estimated that the legs ended at about 0.45 times the person's height and the head started at about 0.75 times the height. To remove these voxels, we used the highest z value max\_z from all the voxels and removed voxels that had a z value that was lower than $0.45 *$ max\_z or higher than $0.75 *$ max\_z.
\section{Possible further improvements}
There are some small things which we would have liked to improve on if we had more time. First, there is some space left to fine tune the histogram more. For example, we did not test any of the other methods for determining the difference between one histogram and another.

There is also some room for performance improvements since we had to turn up the step size to 64 in order to make testing manageable. We think that some of the calculations could be parallelized in order to lower the compute time of a frame. But since this was not a requirement for the assignment we focused on the other parts which were.

We could also improve the optimal HSV values by using true foreground for every camera instead of just one. Doing this will give us more robust HSV values which are optimal for each camera instead of just one. We have chosen not to do this since making these true foregrounds by hand is very time consuming.

We can also improve on which voxels to use to determine the color models. Currently, we are using a very rough estimate of which voxels represent the legs and head for each person, based on the video. A better approach would be to observe the color data itself and use it to determine the optimal thresholds for the legs and head.

Lastly, we estimated the best parameters for the ghost voxel removal by hand, by just looking at the output and comparing a few frames which proved difficult to cluster correctly. This could most likely be improved by using an objective measure to determine how well the voxels were tracked over all frames. 

%----------------------------------------------------------------------------------------
%	REFERENTIES
%----------------------------------------------------------------------------------------
%Meer informatie hierover volgt in blok 5 van jaar 1.

\nocite{*}
\bibliographystyle{acm}
%\bibliographystyle{apalike}
%\bibliography{refs}

%----------------------------------------------------------------------------------------
%	BIJLAGEN
%----------------------------------------------------------------------------------------

%\section{Bijlage A}
%\section{Bijlage B}
%\section{Bijlage C}

\end{document}